import sublime, sublime_plugin
execcmd = __import__("exec")
import re
import os.path
import oracle_helpers


RE_ENTITIES = re.compile("^\\((.+?)/([0-9]+):([0-9]+)\\) [0-9]+:[0-9]+ (.+)$", re.M)


class OracleExecCommand(execcmd.ExecCommand):
    def run(self, dsn="", **kwargs):
        # Find entities declaration in source
        self.entities = oracle_helpers.find_entities(self.window.active_view())
        # Create a string for the in of sql command
        sqlfilter = '"' + ",".join("'%s'" % entity for entity in self.entities.keys()) + '"'

        cmd = ["sqlplus.exe", "-s", dsn, "@", os.path.join(sublime.packages_path(), 'OracleSQL', 'RunSQL.sql'),
                self.window.active_view().file_name(), sqlfilter]

        super(OracleExecCommand, self).run(cmd, "^Filename: (.+)$", "^\\(.+?/([0-9]+):([0-9]+)\\) [0-9]+:[0-9]+ (.+)$", **kwargs)

    def append_data(self, proc, data):
        # Update the line number of output_view with the correct line number of source view
        for re_ent in RE_ENTITIES.finditer(data):
            pos = re_ent.span(2)
            sourceoffset = self.entities[re_ent.group(1)]
            sqlerrorline = int(re_ent.group(2))
            sourceline = sqlerrorline + sourceoffset

            data = data[:pos[0]] + str(sourceline) + data[pos[1]:]

        super(OracleExecCommand, self).append_data(proc, data)
