import sublime, sublime_plugin
import oracle_helpers


class OracleGotoBodyCommand(sublime_plugin.TextCommand):
    def run(self, edit):
        def OnDone(result):
            try:
                ln = int(result) - 1

                if ln >= 0:
                    row, col = self.view.rowcol(pkgbody.begin())
                    pos = self.view.text_point(row + ln, 0)
                    reg = sublime.Region(pos, pos)
                    self.view.sel().clear()
                    self.view.sel().add(reg)
                    self.view.show(reg)
            except:
                ln = None

        pkgbody = oracle_helpers.find_body(self.view)
        if pkgbody:
            self.view.window().show_input_panel('Package body line number:', '', OnDone, OnDone, None)
        else:
            sublime.error_message('Error: Package body not found !')


class OracleExecuteListCommand(sublime_plugin.WindowCommand):
    instance_list = [["MASTER COMPANY", "DEVELOP/DEVELOP@DEV1252A"], ["MASTER PCS", "PCS/PCS@DEV1252A"],
                    ["10.02 COMPANY", "DEMO_MAS_F/DEMO_MAS_F@T1002U"], ["10.01 COMPANY", "MAS_F/MAS_F@T4001U"]]

    def run(self, *args, **kwargs):
        self.window.show_quick_panel(self.instance_list, self._quick_panel_callback)

    def _quick_panel_callback(self, index):
        if (index > -1):
            self.window.run_command("oracle_exec", {"dsn": self.instance_list[index][1]})
